#----------------------------------------------------------------------------------
#---- R function to compute Power and Robustness of single-SNP analysis -----------
#----------------------------------------------------------------------------------

#------------------ Load source --------------------------------------------------
source(file="fonctions/RobPower.r")
source(file="fonctions/creeA.r")
source(file="fonctions/recupA.r")

#------------------ Example 1 -----------------------------------------------------
#-- Article application with 60 progeny by sire and a total of 600 progeny --------
# Read pedigree file and create the relationship matrix A
creation = creeA(fileped="ped-article")
A = creation[[1]]
D = creation[[2]]

# Use RobPower fonction to compute robustness and power 
RobPower(A,D,h2=c(0.1,0.2),threshold=0.05,var.QTL=c(0.01,0.05),methods=c("reg","grammar","qtdt","fasta"),GC=FALSE,r2=1)
#------------------ End Example 1  ------------------------------------------------


#------------------ Example 2 -----------------------------------------------------
#-- Application with real pedigree data  ------------------------------------------
# Read the relationship matrix A which is already available
Afull = read.table(file="A.txt",header=FALSE)
# Create A matrix and D matrix with only recorded individuals
creation = recupA(fileped="ped-real",Afull)
A = creation[[1]]
D = creation[[2]]

# Use RobPower fonction to compute robustness and power 
RobPower(A,D,h2=seq(0.1,0.5,0.1),threshold=0.05,var.QTL=0.02,methods=c("reg","fasta"),GC=TRUE,r2=0.4)
#------------------ End Example 2  -----------------------------------------------


