regression <- function(A,n,threshold,h2,var.QTL,vary,xprimx,xprimAx,GC,tmpvQTL){
	beta = sqrt(var.QTL)
	trA = sum(diag(A))
	v1 = rep(1,n)
	v1primv1 = t(v1)%*%v1
	v1primAv1 = t(v1)%*%A%*%v1

	e.num = (beta[2:length(beta)]/sqrt(vary))*sqrt(xprimx)
	e.denom = 1+(h2*((trA-(1/xprimx)*xprimAx-(1/v1primv1)*v1primAv1-(n-2))/(n-2)))

	v.num=1+h2*(xprimAx*(1/xprimx)-1)
	v.denom=e.denom
	v=v.num/v.denom

	robustness=2*(1-pnorm(qnorm(1-(threshold/2),0,1),0,sqrt(v)))

	e = matrix(0,length(h2),length(beta)-1)
	power = matrix(0,length(h2),length(beta)-1)
	for(i in 1:length(h2)) {
		e[i,]=e.num/sqrt(e.denom[i])	
		power[i,]=1-pnorm(qnorm(1-(threshold/2),0,1),e[i,],sqrt(v[i]))
	}
	
	a=cbind(h2,robustness)
	b=power
	rownames(b) <- as.character(h2)
	colnames(b) <- as.character(tmpvQTL[1:length(tmpvQTL)])

	if(GC==TRUE){
		c=cbind(h2,v)
		colnames(c) <- c("h2","GC")
		return(list(a,b,c))
	} else {
		return(list(a,b))
	}
}